FLTK 1.4.4: Fl_BMP_Image Class Reference

FLTK 1.4.4

Loading...
Searching...
No Matches
Fl_BMP_Image Class Reference

The Fl_BMP_Image class supports loading, caching, and drawing of Windows Bitmap (BMP) image files. More...

`#include <Fl_BMP_Image.H>`

Inheritance diagram for Fl_BMP_Image:

## Public Member Functions
| Fl_BMP_Image (const char *filename)
| This constructor loads the named BMP image from the given BMP filename.
| Fl_BMP_Image (const char *imagename, const unsigned char *data, const long length=-1)
| This constructor loads a BMP image from memory.
Public Member Functions inherited from Fl_RGB_Image
virtual Fl_SVG_Image * | as_svg_image ()
| Returns whether an image is an Fl_SVG_Image or not.
int | cache_h ()
int | cache_w ()
void | color_average (Fl_Color c, float i) FL_OVERRIDE
| The color_average() method averages the colors in the image with the provided FLTK color value.
Fl_Image * | copy () const
Fl_Image * | copy (int W, int H) const FL_OVERRIDE
| Creates a resized copy of the image.
void | desaturate () FL_OVERRIDE
| The desaturate() method converts an image to grayscale.
void | draw (int X, int Y)
void | draw (int X, int Y, int W, int H, int cx=0, int cy=0) FL_OVERRIDE
| Draws the image to the current drawing surface with a bounding box.
| Fl_RGB_Image (const Fl_Pixmap *pxm, Fl_Color bg=FL_GRAY)
| The constructor creates a new RGBA image from the specified Fl_Pixmap.
| Fl_RGB_Image (const uchar *bits, int bits_length, int W, int H, int D, int LD)
| The constructor creates a new image from the specified data.
| Fl_RGB_Image (const uchar *bits, int W, int H, int D=3, int LD=0)
| The constructor creates a new image from the specified data.
void | label (Fl_Menu_Item *m) FL_OVERRIDE
| This method is an obsolete way to set the image attribute of a menu item.
void | label (Fl_Widget *w) FL_OVERRIDE
| This method is an obsolete way to set the image attribute of a widget or menu item.
virtual void | normalize ()
| Makes sure the object is fully initialized.
void | uncache () FL_OVERRIDE
| If the image has been cached for display, delete the cache data.
| ~Fl_RGB_Image () FL_OVERRIDE
| The destructor frees all memory and server resources that are used by the image.
Public Member Functions inherited from Fl_Image
virtual class Fl_Shared_Image * | as_shared_image ()
| Returns whether an image is an Fl_Shared_Image or not.
Fl_Image * | copy () const
| Creates a copy of the image in the same size.
int | count () const
| Returns the number of data values associated with the image.
int | d () const
| Returns the image depth.
const char *const * | data () const
| Returns a pointer to the current image data array.
int | data_h () const
| Returns the height of the image data.
int | data_w () const
| Returns the width of the image data.
void | draw (int X, int Y)
| Draws the image to the current drawing surface.
int | fail () const
| Returns a value that is not 0 if there is currently no image available.
| Fl_Image (int W, int H, int D)
| The constructor creates an empty image with the specified width, height, and depth.
int | h () const
| Returns the current image drawing height in FLTK units.
void | inactive ()
| The inactive() method calls color_average(FL_BACKGROUND_COLOR, 0.33f) to produce an image that appears grayed out.
int | ld () const
| Returns the current line data size in bytes.
virtual void | release ()
| Releases an Fl_Image - the same as '`delete` `this'`.
virtual void | scale (int width, int height, int proportional=1, int can_expand=0)
| Sets the drawing size of the image.
int | w () const
| Returns the current image drawing width in FLTK units.
virtual | ~Fl_Image ()
| The destructor is a virtual method that frees all memory used by the image.

## Protected Member Functions
void | load_bmp_ (class Fl_Image_Reader &rdr, int ico_height=0, int ico_width=0)
Protected Member Functions inherited from Fl_Image
void | d (int D)
| Sets the current image depth.
void | data (const char *const *p, int c)
| Sets the current data pointer and count of pointers in the array.
void | draw_empty (int X, int Y)
| The protected method draw_empty() draws a box with an X in it.
int | draw_scaled (int X, int Y, int W, int H)
| Draw the image to the current drawing surface rescaled to a given width and height.
void | h (int H)
| Sets the height of the image data.
void | ld (int LD)
| Sets the current line data size in bytes.
void | w (int W)
| Sets the width of the image data.

## Additional Inherited Members
Static Public Member Functions inherited from Fl_RGB_Image
static size_t | max_size ()
| Returns the maximum allowed image size in bytes when creating an Fl_RGB_Image object.
static void | max_size (size_t size)
| Sets the maximum allowed image size in bytes when creating an Fl_RGB_Image object.
Static Public Member Functions inherited from Fl_Image
static Fl_Labeltype | define_FL_IMAGE_LABEL ()
static Fl_RGB_Scaling | RGB_scaling ()
| Returns the currently used RGB image scaling method.
static void | RGB_scaling (Fl_RGB_Scaling)
| Sets the RGB image scaling method used for copy(int, int).
static Fl_RGB_Scaling | scaling_algorithm ()
| Gets what algorithm is used when resizing a source image to draw it.
static void | scaling_algorithm (Fl_RGB_Scaling algorithm)
| Sets what algorithm is used when resizing a source image to draw it.
Public Attributes inherited from Fl_RGB_Image
int | alloc_array
| If non-zero, the object's data array is delete[]'d when deleting the object.
const uchar * | array
| Points to the start of the object's data array.
Static Public Attributes inherited from Fl_Image
static const int | ERR_FILE_ACCESS = -2
static const int | ERR_FORMAT = -3
static const int | ERR_MEMORY_ACCESS = -4
static const int | ERR_NO_IMAGE = -1
static bool | register_images_done = false
| True after fl_register_images() was called, false before.
Static Protected Member Functions inherited from Fl_Image
static void | labeltype (const Fl_Label *lo, int lx, int ly, int lw, int lh, Fl_Align la)
static void | measure (const Fl_Label *lo, int &lw, int &lh)

## Detailed Description

The Fl_BMP_Image class supports loading, caching, and drawing of Windows Bitmap (BMP) image files.

## Constructor & Destructor Documentation

## ◆ Fl_BMP_Image() [1/2]

Fl_BMP_Image::Fl_BMP_Image | ( | const char * | filename | ) |

This constructor loads the named BMP image from the given BMP filename.

The destructor frees all memory and server resources that are used by the image.

Use Fl_Image::fail() to check if Fl_BMP_Image failed to load. fail() returns ERR_FILE_ACCESS if the file could not be opened or read, ERR_FORMAT if the BMP format could not be decoded, and ERR_NO_IMAGE if the image could not be loaded for another reason.

Parameters

  [in] | filename | a full path and name pointing to a BMP file.

See also
  Fl_BMP_Image::Fl_BMP_Image(const char* imagename, const unsigned char *data, const long length = -1);

## ◆ Fl_BMP_Image() [2/2]

Fl_BMP_Image::Fl_BMP_Image | ( | const char * | imagename,
|  | const unsigned char * | data,
|  | const long | length = -1 )

This constructor loads a BMP image from memory.

Construct an image from a block of memory inside the application. Fluid offers "binary data" chunks as a great way to add image data into the C++ source code. `imagename` can be NULL. If a name is given, the image is added to the list of shared images and will be available by that name.

The destructor frees all memory and server resources that are used by the image.

The (new and optional) third parameter `length` should be used so buffer overruns (i.e. truncated images) can be checked. See note below.

If `length` is not used

- it defaults to -1 (unlimited size)
- buffer overruns will not be checked.

Note
  The optional parameter `length` is available since FLTK 1.4.0. Not using it is deprecated and old code should be modified to use it. This parameter will likely become mandatory in a future FLTK version.

Use Fl_Image::fail() to check if Fl_BMP_Image failed to load. fail() returns ERR_FILE_ACCESS if the image could not be read from memory, ERR_FORMAT if the BMP format could not be decoded, and ERR_NO_IMAGE if the image could not be loaded for another reason.

Parameters

  [in] | imagename | A name given to this image or NULL
  [in] | data | Pointer to the start of the BMP image in memory.
  [in] | length | Length of the BMP image in memory.

See also
  Fl_BMP_Image::Fl_BMP_Image(const char *filename)
  Fl_Shared_Image

The documentation for this class was generated from the following files:

- Fl_BMP_Image.H
- Fl_BMP_Image.cxx